// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "assert/assert.hpp"

namespace Dawn {
  class DawnGame;

  class IAudioManager {
    protected:
      DawnGame *game;

    public:
      /**
       * Construct a new IAudioManager.
       * 
       * @param game The game instance.
       */
      IAudioManager(DawnGame *game);
      
      /**
       * Initializes the audio manager system.
       */
      virtual void init() = 0;

      /**
       * Ticks/Update the audio manager system.
       */
      virtual void update() = 0;
  };
}