// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "VNManager.hpp"
#include "games/vn/events/VNEvent.hpp"

using namespace Dawn;

VNManager::VNManager(SceneItem *item) :
  SceneItemComponent(item),
  defaultFont("<font font=\"font_main\">{{ text }}</font>")
{
}

void VNManager::onStart() {
  if(this->currentEvent != nullptr) {
    this->currentEvent->start(this, nullptr);
  }
}

void VNManager::setEvent(VNEvent *event) {
  this->currentEvent = event;
}

void VNManager::setFlag(std::string key, std::string value) {
  this->flags[key] = value;
}

std::string VNManager::getFlag(std::string key) {
  if(this->flags.find(key) == this->flags.end()) return "";
  return this->flags[key];
}

void VNManager::onDispose() {
  
}