// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/components/display/mesh/MeshHost.hpp"
#include "display/RenderTarget.hpp"
#include "display/mesh/QuadMesh.hpp"

namespace Dawn {
  class SimpleRenderTargetQuad : public SceneItemComponent {
    protected:
      MeshHost *meshHost = nullptr;
      std::function<void()> evtResized;

    public:
      // @optional
      StateProperty<RenderTarget*> renderTarget;

      /**
       * Creates a SimpleRenderTargetQuad scene item component. This component
       * will update the attached MeshHost any time the render target provided
       * is updated / resized.
       * 
       * @param item Item that this component is attached to.
       */
      SimpleRenderTargetQuad(SceneItem *item);
      
      std::vector<SceneItemComponent*> getDependencies() override;
      void onStart() override;
  };
}